--[[
	Copyright (C) 2013 Mikhail Emelchenkov (http://mikhail.guru)
	Distributed under Microsoft Reference Source License (MS-RSL)
]]--

-- Hard-coded paths to run program remotely via Koneki Lua Remote Application
package.path = "./?.lua;/usr/local/share/lua/5.1/?.lua;/usr/local/share/lua/5.1/?/init.lua;/usr/local/lib/lua/5.1/?.lua;/usr/local/lib/lua/5.1/?/init.lua;/usr/share/lua/5.1/?.lua;/usr/share/lua/5.1/?/init.lua"
package.cpath = "./?.so;/usr/local/lib/lua/5.1/?.so;/usr/lib/lua/5.1/?.so;/usr/local/lib/lua/5.1/loadall.so;"
-- LZO module path
package.cpath = package.cpath .. "/root/lua_so/?.so;/root/lua_so/lua_?.so"

require "luarocks.loader"
nio = require "nixio"		-- Support for working with large files
require "struct"
md5 = require "md5"
require "pluto"		-- Proprietary module
require "lzo"		-- Proprietary module
require "utils"

local firmwarePath = "/root/original/firmware.bin"
local userImageOutPath = "/root/original/userImage.tar.gz"
local dataImageOutPath = "/root/original/dataImage.tar.gz"
context = { data = "", dataPtr = 0 }

local function main()
	context.file = nio.open(firmwarePath, "r")
	local userOut = nio.open(userImageOutPath, "w")
	local dataOut = nio.open(dataImageOutPath, "w")
	
	extractUserDataImages(context, userOut, dataOut)
	
	context.file:close()
	userOut:close()
	dataOut:close()
end
main()

